const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const guardians = sequelize.define(
    'guardians',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

primary_phone: {
        type: DataTypes.TEXT,
      
      

      },

secondary_phone: {
        type: DataTypes.TEXT,
      
      

      },

address_line1: {
        type: DataTypes.TEXT,
      
      

      },

city: {
        type: DataTypes.TEXT,
      
      

      },

state: {
        type: DataTypes.TEXT,
      
      

      },

postal_code: {
        type: DataTypes.TEXT,
      
      

      },

emergency_contact_name: {
        type: DataTypes.TEXT,
      
      

      },

emergency_contact_phone: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  guardians.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












    db.guardians.hasMany(db.campers, {
      as: 'campers_primary_guardian',
      foreignKey: {
          name: 'primary_guardianId',
      },
      constraints: false,
    });





    db.guardians.hasMany(db.document_signatures, {
      as: 'document_signatures_guardian',
      foreignKey: {
          name: 'guardianId',
      },
      constraints: false,
    });













//end loop



    db.guardians.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });




    db.guardians.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.guardians.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return guardians;
};


